//***********************************************************************
//
//                              JPanelGenerateSample.java
//
// Author(s) : Jean-luc LABLEE
// FISPRO Version : 3.2 - Copyright INRA - Cemagref - 2002 - IDDN.FR.001.030024.000.R.P.2005.003.31235
// Licence http://www.cecill.info/licences/Licence_CeCILL_V2-en.html/
// Last modification date:  July 31, 2009 - Contact : fispro@supagro.inra.fr
//
//**********************************************************************
package fis;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.util.Vector;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class JPanelGenerateSample extends JPanel {

    private JLabel jLabelSampleNumber = null;

    private IntegerField integerFieldSampleNumber = null;

    private JLabel jLabelValidationDataRatio = null;

    private IntegerField integerFieldValidationDataRatio = null;

    private JLabel jLabelPercent = null;

    private JCheckBox jCheckBoxClassif = null;

    private JCheckBox jCheckBoxReplace = null;

    private JCheckBox jCheckBoxNotReplace = null;

    private JCheckBox jCheckBoxTruncate = null;

    private JLabel jLabelSeed = null;

    private IntegerField integerFieldSeed = null;

    private JLabel jLabelPrecision = null;

    private DoubleField doubleFieldPrecision = null;

    private JExtendedDataFile dataFile = null;

    private JComboBox jComboBoxColumnNumber = null;

    private JFIS fis = null;

    /**
     * This method initializes 
     * @param fis TODO
     * 
     */
    public JPanelGenerateSample(JExtendedDataFile dataFile, JFIS fis) {
        super();
        this.dataFile = dataFile;
        this.fis = fis;
        initialize();
        // init classif jCheckBoxClassif
        boolean classif = false;
        try {
            classif = this.fis == null ? false : ((JOutput) this.GetInput(this.dataFile.VariableCount())).GetClassif();
        } catch (Throwable e1) {
            classif = false;
        }
        jCheckBoxClassif.setSelected(classif);
        this.setClassif(classif);
        // remplissage de jComboBoxColumnNumber
        Vector items = new Vector();
        for (int i = 0; i < this.dataFile.VariableCount(); i++) {
            try {
                items.add(this.VariableName(i));
            } catch (Throwable e) {
                items.add(Integer.toString(i + 1));
            }
        }
        jComboBoxColumnNumber.setModel(new DefaultComboBoxModel(items));
        jComboBoxColumnNumber.setSelectedIndex(this.dataFile.VariableCount() - 1);

	jCheckBoxReplace.setSelected(true);
	// init replace for jCheckBoxReplace
        boolean replace = false;
	jCheckBoxNotReplace.setSelected(false);
	jCheckBoxTruncate.setSelected(false);
	jCheckBoxTruncate.setEnabled(false);
    }

    /**
     * This method initializes this
     * 
     */
    private void initialize() {
        
        
        
	// gridy=7:  seed
        GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
        gridBagConstraints4.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints4.gridy = 7;
        gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints4.insets = new java.awt.Insets(5, 5, 0, 5);
        gridBagConstraints4.ipadx = 40;
        gridBagConstraints4.gridx = 1;
        GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
        gridBagConstraints3.gridx = 0;
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints3.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints3.gridy = 7;
	//

        GridBagConstraints gridBagConstraints33 = new GridBagConstraints();
        gridBagConstraints33.gridx = 0;
        gridBagConstraints33.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints33.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints33.gridy = 4;
	
	GridBagConstraints gridBagConstraints33d = new GridBagConstraints();
        gridBagConstraints33d.gridx = 1;
        gridBagConstraints33d.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints33d.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints33d.gridy = 4;

	GridBagConstraints gridBagConstraints44 = new GridBagConstraints();
        gridBagConstraints44.gridx = 0;
        gridBagConstraints44.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints44.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints44.gridy = 2;

	jLabelSeed = new JLabel();
        jLabelSeed.setText(LocaleFIS.GetString("Seed") + ":");

	// gridy=5: classif + variable classif
        GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
        gridBagConstraints2.gridx = 0;
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints2.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints2.gridy = 5;

	GridBagConstraints gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridx = 1;
	//

	// gridy=6:  precision
	GridBagConstraints gridBagConstraints71 = new GridBagConstraints();
        gridBagConstraints71.gridx = 0;
        gridBagConstraints71.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints71.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints71.gridy = 6;
        jLabelPrecision = new JLabel();
	jLabelPrecision.setText(LocaleFIS.GetString("Precision") + ":");
        jLabelPrecision.setEnabled(false);

	GridBagConstraints gridBagConstraints81 = new GridBagConstraints();
        gridBagConstraints81.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints81.gridy = 6;
        gridBagConstraints81.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints81.insets = new java.awt.Insets(5, 5, 0, 5);
        //gridBagConstraints81.ipadx = 40;
        gridBagConstraints.gridwidth = 2;
	gridBagConstraints81.gridx = 1;
	//

        GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.insets = new java.awt.Insets(5, 0, 0, 5);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.gridy = 3;
        jLabelPercent = new JLabel();
        jLabelPercent.setText("%");
        GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
        gridBagConstraints9.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints9.gridy = 3;
        gridBagConstraints9.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints9.insets = new java.awt.Insets(5, 5, 0, 5);
        gridBagConstraints9.ipadx = 40;
        gridBagConstraints9.gridx = 1;
        GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
        gridBagConstraints8.gridx = 0;
        gridBagConstraints8.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints8.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints8.gridy = 3;
        jLabelValidationDataRatio = new JLabel();
        jLabelValidationDataRatio.setText(LocaleFIS.GetString("ValidationDataRatio") + ":");
        GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
        gridBagConstraints7.fill = java.awt.GridBagConstraints.NONE;
        gridBagConstraints7.gridy = 1;
        gridBagConstraints7.insets = new java.awt.Insets(5, 5, 0, 5);
        gridBagConstraints7.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints7.ipadx = 40;
        gridBagConstraints7.gridx = 1;
        GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
        gridBagConstraints6.gridx = 0;
        gridBagConstraints6.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints6.insets = new java.awt.Insets(5, 5, 0, 0);
        gridBagConstraints6.gridy = 1;
        jLabelSampleNumber = new JLabel();
        jLabelSampleNumber.setText(LocaleFIS.GetString("SampleNumber") + ":");
        this.setLayout(new GridBagLayout());
        this.setSize(new java.awt.Dimension(411, 330));
        this.add(jLabelSampleNumber, gridBagConstraints6);
        this.add(getIntegerFieldSampleNumber(), gridBagConstraints7);
        this.add(getIntegerFieldValidationDataRatio(), gridBagConstraints9);
        this.add(jLabelValidationDataRatio, gridBagConstraints8);
        this.add(jLabelPercent, gridBagConstraints1);
        this.add(getJCheckBoxClassif(), gridBagConstraints2);
        this.add(jLabelSeed, gridBagConstraints3);
	
	this.add(getJCheckBoxNotReplace(), gridBagConstraints33);
	this.add(getJCheckBoxReplace(), gridBagConstraints44);
	this.add(getJCheckBoxTruncate(), gridBagConstraints33d);

        this.add(getIntegerFieldSeed(), gridBagConstraints4);
        this.add(jLabelPrecision, gridBagConstraints71);
        this.add(getDoubleFieldPrecision(), gridBagConstraints81);
        this.add(getJComboBoxColumnNumber(), gridBagConstraints);
    }

    /**
     * This method initializes integerField2	
     * 	
     * @return fis.IntegerField	
     */
    private IntegerField getIntegerFieldSampleNumber() {
        if (integerFieldSampleNumber == null) {
            integerFieldSampleNumber = new IntegerField();
            integerFieldSampleNumber.setValue(1);
        }
        return integerFieldSampleNumber;
    }

    /**
     * This method initializes integerField3	
     * 	
     * @return fis.IntegerField	
     */
    private IntegerField getIntegerFieldValidationDataRatio() {
        if (integerFieldValidationDataRatio == null) {
            integerFieldValidationDataRatio = new IntegerField();
            integerFieldValidationDataRatio.setValue(75);
        }
        return integerFieldValidationDataRatio;
    }

    /**
     * This method initializes jCheckBoxClassif	
     * 	
     * @return javax.swing.JCheckBox	
     */
    private JCheckBox getJCheckBoxClassif() {
        if (jCheckBoxClassif == null) {
            jCheckBoxClassif = new JCheckBox();
            jCheckBoxClassif.setText(LocaleFIS.GetString("Classif"));
            jCheckBoxClassif.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    setClassif(jCheckBoxClassif.isSelected());
                }
            });
        }
        return jCheckBoxClassif;
    }

    /**
     * This method initializes jCheckBoxReplace
     * 	
     * @return javax.swing.JCheckBox	
     */
    private JCheckBox getJCheckBoxReplace() {
        if (jCheckBoxReplace == null) {
            jCheckBoxReplace = new JCheckBox();
            jCheckBoxReplace.setText(LocaleFIS.GetString("Replace"));
            jCheckBoxReplace.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                   setReplace(jCheckBoxReplace.isSelected());
                }
            });
        }
        return jCheckBoxReplace;
    }

    /**
     * This method initializes jCheckBoxNotReplace
     * 	
     * @return javax.swing.JCheckBox	
     */
    private JCheckBox getJCheckBoxNotReplace() {
        if (jCheckBoxNotReplace == null) {
            jCheckBoxNotReplace = new JCheckBox();
            jCheckBoxNotReplace.setText(LocaleFIS.GetString("NotReplace"));
            jCheckBoxNotReplace.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                   setNotReplace(jCheckBoxNotReplace.isSelected());
                }
            });
        }
        return jCheckBoxNotReplace;
    }

/**
     * This method initializes jCheckBoxTruncate
     * 	
     * @return javax.swing.JCheckBox	
     */
    private JCheckBox getJCheckBoxTruncate() {
        if (jCheckBoxTruncate == null) {
            jCheckBoxTruncate = new JCheckBox();
            jCheckBoxTruncate.setText(LocaleFIS.GetString("Truncate"));
	}
        return jCheckBoxTruncate;
    }

    /**
     * This method initializes integerFieldSeed	
     * 	
     * @return fis.IntegerField	
     */
    private IntegerField getIntegerFieldSeed() {
        if (integerFieldSeed == null) {
            integerFieldSeed = new IntegerField();
            integerFieldSeed.setValue(0);
        }
        return integerFieldSeed;
    }

    /**
     * This method initializes doubleField	
     * 	
     * @return fis.DoubleField	
     */
    private DoubleField getDoubleFieldPrecision() {
        if (doubleFieldPrecision == null) {
            doubleFieldPrecision = new DoubleField();
            doubleFieldPrecision.setValue(0.01D);
            doubleFieldPrecision.setEnabled(false);
        }
        return doubleFieldPrecision;
    }

    public int getSampleNumber() {
        return this.integerFieldSampleNumber.getValue();
    }

    public double getValidationDataRatio() {
        return (double) this.integerFieldValidationDataRatio.getValue() / 100;
    }

    public int getSeed() {
        return this.integerFieldSeed.getValue();
    }

    public boolean getClassif() {
        return this.jCheckBoxClassif.isSelected();
    }

    public int getColumnNumber() {
        return this.jComboBoxColumnNumber.getSelectedIndex();
    }

    public double getPrecision() {
        return this.doubleFieldPrecision.getValue();
    }

    public boolean getReplace() {
        return this.jCheckBoxReplace.isSelected();
    }

    public boolean getNotReplace() {
        return this.jCheckBoxNotReplace.isSelected();
    }
    
    public boolean getTruncate() {
        return this.jCheckBoxTruncate.isSelected();
    }

    /**
     * This method initializes jComboBoxColumnNumber	
     * 	
     * @return javax.swing.JComboBox	
     */
    private JComboBox getJComboBoxColumnNumber() {
        if (jComboBoxColumnNumber == null) {
            jComboBoxColumnNumber = new JComboBox();
            jComboBoxColumnNumber.setEnabled(false);
        }
        return jComboBoxColumnNumber;
    }

    private String VariableName(int index) throws Throwable {
        if (this.fis == null) { // il n'y a pas de sif ouvert
            if (this.dataFile.getVariableName() == null)
                return LocaleFIS.GetString("Variable") + " " + Integer.toString(index + 1); // retourne variable index
            else
                return this.dataFile.getVariableName()[index];
        } else
            // un sif est ouvert
            return this.GetInput(index).GetName(); // retourne le nom de l'entree
    }

    private JInput GetInput(int index) throws Throwable {
        if (this.fis != null)
            if (index < this.fis.NbInputs()) // index correspond a une entree
                return this.fis.GetInput(index);
            else
                // index correspond a une sortie
                return this.fis.GetOutput(index - this.fis.NbInputs());
        else
            return null;
    }

    private void setClassif(boolean classif) {
        jComboBoxColumnNumber.setEnabled(classif);
        jLabelPrecision.setEnabled(classif);
        doubleFieldPrecision.setEnabled(classif);
    }

    private void setReplace(boolean replace) {
	jCheckBoxNotReplace.setSelected(!replace);
        integerFieldValidationDataRatio.setEnabled(replace);
	jCheckBoxTruncate.setEnabled(!replace);
	if ( ! replace && (getSampleNumber() == 1)) {
	    integerFieldSampleNumber.setValue(2);
        }
    }
    
    private void setNotReplace(boolean replace) {
	jCheckBoxReplace.setSelected(!replace);
	integerFieldValidationDataRatio.setEnabled(!replace);
	jCheckBoxTruncate.setEnabled(replace);
        if ( replace && (getSampleNumber() == 1)) {
	    integerFieldSampleNumber.setValue(2);
	}
    }
    
}
